Index: Makefile
===================================================================
--- Makefile	(revision 366019)
+++ Makefile	(working copy)
@@ -1,10 +1,10 @@
 # $FreeBSD$
 
 PORTNAME=	Ocsinventory
-PORTVERSION=	2.0.5
+PORTVERSION=	2.1.1
 PORTEPOCH=	1
 CATEGORIES=	net-mgmt
-MASTER_SITES=	http://launchpad.net/ocsinventory-unix-agent/stable-2.0/${PORTVERSION}/+download/
+MASTER_SITES=	http://launchpad.net/ocsinventory-unix-agent/stable-2.1/${PORTVERSION}/+download/
 PKGNAMESUFFIX=	-Unix-Agent
 DISTNAME=	${PORTNAME}${PKGNAMESUFFIX}-${PORTVERSION}
 
@@ -13,17 +13,42 @@
 
 LICENSE=	GPLv2
 
-RUN_DEPENDS=	p5-libwww>=0:${PORTSDIR}/www/p5-libwww \
+RUN_DEPENDS=	lspci:${PORTSDIR}/sysutils/pciutils \
 		p5-XML-Simple>=0:${PORTSDIR}/textproc/p5-XML-Simple \
 		p5-Net-IP>=0:${PORTSDIR}/net-mgmt/p5-Net-IP \
-		p5-Proc-Daemon>=0:${PORTSDIR}/devel/p5-Proc-Daemon
-BUILD_DEPENDS=	dmidecode:${PORTSDIR}/sysutils/dmidecode \
-		lspci:${PORTSDIR}/sysutils/pciutils
+		p5-Proc-Daemon>=0:${PORTSDIR}/devel/p5-Proc-Daemon \
+		dmidecode:${PORTSDIR}/sysutils/dmidecode \
+		p5-Digest-MD5>=0:${PORTSDIR}/security/p5-Digest-MD5
 
 USES=		perl5
 USE_PERL5=	configure
+CONFIGURE_ENV=	PERL_AUTOINSTALL=1
 WRKSRC=		${WRKDIR}/${PORTNAME}${PKGNAMESUFFIX}-${PORTVERSION}
 SUB_FILES=	pkg-message
 SUB_LIST=	SITE_PERL=${SITE_PERL}
 
+# define options
+OPTIONS_DEFINE=	DAEMON IPMI SSL PRINTER SNMP
+
+DAEMON_DESC=	Daemon mode
+IPMI_DESC=	Collect information about IPMI
+SSL_DESC=	Get SSL communications working
+PRINTER_DESC=	Printers detection
+SNMP_DESC=	Scan network devices using SNMP
+
+# define default options
+OPTIONS_DEFAULT=	SSL SNMP
+
+DAEMON_RUN_DEPENDS=	p5-Proc-Daemon>=0:${PORTSDIR}/devel/p5-Proc-Daemon \
+			p5-Proc-PID-File>=0:${PORTSDIR}/devel/p5-Proc-PID-File
+IPMI_RUN_DEPENDS=	ipmitool:${PORTSDIR}/sysutils/ipmitool
+SSL_RUN_DEPENDS=	p5-Crypt-SSLeay>=0:${PORTSDIR}/security/p5-Crypt-SSLeay \
+			p5-LWP-Protocol-https>=0:${PORTSDIR}/www/p5-LWP-Protocol-https
+PRINTER_RUN_DEPENDS=	p5-Net-CUPS>=0:${PORTSDIR}/print/p5-Net-CUPS
+SNMP_RUN_DEPENDS=	p5-Net-SNMP>=0:${PORTSDIR}/net-mgmt/p5-Net-SNMP \
+			p5-Net-Netmask>=0:${PORTSDIR}/net-mgmt/p5-Net-Netmask \
+			p5-Net-Ping>=0:${PORTSDIR}/net/p5-Net-Ping \
+			p5-Nmap-Parser>=0:${PORTSDIR}/security/p5-Nmap-Parser \
+			nmap:${PORTSDIR}/security/nmap
+
 .include <bsd.port.mk>
Index: distinfo
===================================================================
--- distinfo	(revision 366019)
+++ distinfo	(working copy)
@@ -1,2 +1,2 @@
-SHA256 (Ocsinventory-Unix-Agent-2.0.5.tar.gz) = 7ef1c25dce5f1e0854abc423513c1733219cc73e4c36057dbdad6757e1609a64
-SIZE (Ocsinventory-Unix-Agent-2.0.5.tar.gz) = 1707443
+SHA256 (Ocsinventory-Unix-Agent-2.1.1.tar.gz) = dc321bc23c73c7d2147e80082f993e0c3faaca8195126050b86d9d3da7cc63a3
+SIZE (Ocsinventory-Unix-Agent-2.1.1.tar.gz) = 1851193
Index: files/patch-Makefile.PL
===================================================================
--- files/patch-Makefile.PL	(revision 366019)
+++ files/patch-Makefile.PL	(working copy)
@@ -1,12 +0,0 @@
---- Makefile.PL.orig	2011-01-04 17:59:37.000000000 +0000
-+++ Makefile.PL	2011-01-04 18:00:04.000000000 +0000
-@@ -11,7 +11,8 @@
- install :: all pure_install doc_install
- 	$(NOECHO) $(NOOP)';
- 
--	$re .= "\n\t[ ! -f run-postinst ] || $^X postinst.pl\n";
-+# Disable the post install script
-+#	$re .= "\n\t[ ! -f run-postinst ] || $^X postinst.pl\n";
- 
-     return $re;
- }
Index: files/pkg-message.in
===================================================================
--- files/pkg-message.in	(revision 366019)
+++ files/pkg-message.in	(working copy)
@@ -1,10 +1,10 @@
 *****************************************************************
 
-This port disabled the post installtion script during the build
+This port disabled the post installation script during the build
 process to allow the package to be built without interaction.
 
 If you wish to run this script it is located here:
-    %%SITE_PERL%%/Ocsinventory/postinst.pl
+    %%SITE_PERL%%/Ocsinventory/Unix/postinst.pl
 
 Note: It may not be required to run this script depending on 
 your environment.
Index: pkg-plist
===================================================================
--- pkg-plist	(revision 366019)
+++ pkg-plist	(working copy)
@@ -1,4 +1,8 @@
 bin/ocsinventory-agent
+%%PERL5_MAN3%%/Ocsinventory::Agent::Common.3.gz
+%%PERL5_MAN3%%/Ocsinventory::Agent::Modules::Apache::Vhosts::Common.3.gz
+%%PERL5_MAN3%%/Ocsinventory::Agent::Modules::Databases::Oracle::Instances.3.gz
+%%PERL5_MAN3%%/Ocsinventory::Agent::XML::Inventory.3.gz
 %%SITE_PERL%%/Ocsinventory/Agent.pm
 %%SITE_PERL%%/Ocsinventory/Agent/AccountConfig.pm
 %%SITE_PERL%%/Ocsinventory/Agent/AccountInfo.pm
@@ -53,6 +57,8 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lspci/Modems.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lspci/Sounds.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lspci/Videos.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lsusb.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lsusb/Usb.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging/BSDpkg.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging/ByHand.pm
@@ -61,7 +67,6 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging/Pacman.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging/RPM.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Printers/Cups.pm
-%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Processes.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Screen.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Users.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/HPUX.pm
@@ -97,6 +102,7 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/LSB.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/ArchLinux.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/CentOS.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Debian.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Fedora.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Gentoo.pm
@@ -103,6 +109,7 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Knoppix.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Mandrake.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Mandriva.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Oracle.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Redhat.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/Slackware.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/SuSE.pm
@@ -111,6 +118,7 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB/VmWare.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Domains.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Drives.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/LVM.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Mem.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Network/IPv4.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Network/Networks.pm
@@ -126,6 +134,7 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Bios.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/CPU.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Controllers.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Domains.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Drives.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Hostname.pm
@@ -134,6 +143,7 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Networks.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Packages.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Printers.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Slots.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Sound.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Storages.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS/Uptime.pm
@@ -159,6 +169,7 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/VirtualBox.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/VmWareDesktop.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/VmWareESX.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/VmWareWorkstation.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/Vmsystem.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/Xen.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/Xen/XM.pm
@@ -165,16 +176,24 @@
 %%SITE_PERL%%/Ocsinventory/Agent/Common.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Config.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Hooks.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Apache/Vhosts/Common.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Apache/VhostsEL.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Databases/Oracle.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Databases/Oracle/Instances.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Download.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Example.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Processes.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/11.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/231.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/2620.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/311.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/3224.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/3375.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/42.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/641.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/7244.pm
+%%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/789.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/8072.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/9.pm
 %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp/Default.pm
@@ -195,47 +214,50 @@
 %%SITE_PERL%%/Ocsinventory/LoggerBackend/Stderr.pm
 %%SITE_PERL%%/Ocsinventory/LoggerBackend/Syslog.pm
 %%SITE_PERL%%/Ocsinventory/Unix/postinst.pl
-%%SITE_PERL%%/mach/auto/Ocsinventory/Unix/Agent/.packlist
-%%PERL5_MAN3%%/Ocsinventory::Agent::Common.3.gz
-%%PERL5_MAN3%%/Ocsinventory::Agent::XML::Inventory.3.gz
+%%SITE_PERL%%/%%PERL_ARCH%%/auto/Ocsinventory/Unix/Agent/.packlist
 man/man1/ocsinventory-agent.1.gz
-@dirrm %%SITE_PERL%%/mach/auto/Ocsinventory/Unix/Agent
-@dirrm %%SITE_PERL%%/mach/auto/Ocsinventory/Unix
-@dirrm %%SITE_PERL%%/mach/auto/Ocsinventory
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/IpDiscover
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/AIX
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/BSD/Archs
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/BSD
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Dmidecode
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lspci
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Printers
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/HPUX
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/ARM
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/Alpha
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/MIPS
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/PowerPC
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/SPARC
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/i386
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/m68k
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Network
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Storages
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Solaris
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/Xen
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Backend
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/Modules
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/XML/Response
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent/XML
-@dirrm %%SITE_PERL%%/Ocsinventory/Agent
-@dirrm %%SITE_PERL%%/Ocsinventory/LoggerBackend
-@dirrm %%SITE_PERL%%/Ocsinventory/Unix
-@dirrm %%SITE_PERL%%/Ocsinventory
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/IpDiscover
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/AIX
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/BSD/Archs
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/BSD
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Dmidecode
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lspci
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Lsusb
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Packaging
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic/Printers
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Generic
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/HPUX
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/ARM
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/Alpha
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/MIPS
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/PowerPC
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/SPARC
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/i386
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs/m68k
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Archs
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro/NonLSB
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Distro
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Network
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux/Storages
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Linux
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/MacOS
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS/Solaris
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/OS
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization/Xen
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend/Virtualization
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Backend
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Modules/Apache/Vhosts
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Modules/Apache
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Modules/Databases/Oracle
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Modules/Databases
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Modules/Snmp
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/Modules
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/XML/Response
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent/XML
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Agent
+@dirrmtry %%SITE_PERL%%/Ocsinventory/LoggerBackend
+@dirrmtry %%SITE_PERL%%/Ocsinventory/Unix
+@dirrmtry %%SITE_PERL%%/Ocsinventory
+@dirrmtry %%SITE_PERL%%/%%PERL_ARCH%%/auto/Ocsinventory/Unix/Agent
+@dirrmtry %%SITE_PERL%%/%%PERL_ARCH%%/auto/Ocsinventory/Unix
+@dirrmtry %%SITE_PERL%%/%%PERL_ARCH%%/auto/Ocsinventory